'============================================================================
'J.M.K S.F. BatchBASIC 1.3b
'(c) 2000 by Jan-Max Meyer Krapohl, owner of J.M.K S.F.
'Programming Language, Compiler and Interpreter Developments & Resources
'http://www.jmksf.de.st/
'jmk.software.factory@web.de

'Dieses Programm ist freie Software. Sie koennen es unter
'den Bedingungen der GNU General Public License, wie von der
'Free Software Foundation herausgegeben, weitergeben und/oder
'modifizieren, entweder unter Version 2 der Lizenz oder (wenn
'Sie es wuenschen) jeder spaeteren Version.

'Die Veroeffentlichung dieses Programms erfolgt in der
'Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE
'GEWAEHRLEISTUNG - sogar ohne die implizite Gewaehrleistung
'der MARKTREIFE oder der EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
'Details finden Sie in der GNU General Public License.

'Sie sollten eine Kopie der GNU General Public License zusammen
'mit diesem Programm erhalten haben. Falls nicht, schreiben Sie
'an die Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
'MA 2139, USA oder an jmk.software.factory@web.de !
'#############################################################################
'#############################################################################
'Es  wird  fr  keine  Schaeden,  die mit dieser Programmiersprache angestellt
'werden oder passieren gehaftet. Der Einsatz in Raum-, Luft-, Wasser- und  Bo-
'denfahreugen, Lebenserhaltungssystemen, militrischen Einrichtungen (Fahrzeu-
'gen, Raketen, Atomsprengkrpern, U-Booten, Maschinengewehren, sonst.  Waffen-
'systemen, usw.) der Programmiersprache ist strengstens verboten.
'#############################################################################

CLS
COLOR 7, 0
PRINT "J.M.K S.F. BatchBASIC 1.3b Interpreter"
PRINT "(c) 2000 by Jan-Max Meyer Krapohl, owner of J.M.K S.F."
PRINT "Programmiersprachen und -tool entwicklungen"
PRINT "http://www.jmksf.de.st/"
PRINT "jmk.software.factory@web.de"
COLOR 4, 0
PRINT
SLEEP 1
COLOR 7, 0
ON ERROR GOTO error1
filename$ = LTRIM$(RTRIM$(COMMAND$))
stringvar$ = ""
markesuch = 0
anfang:
OPEN filename$ FOR INPUT AS #1
IF markesuch = 0 THEN GOTO ladeweiter
'Wenn markesuch den Wert 1 hat, suche Marke !
markname$ = "#" + markname$
DO UNTIL EOF(1)
INPUT #1, inputcode$
IF inputcode$ = markname$ THEN EXIT DO
LOOP
markesuch = 0
ladeweiter:
DO
INPUT #1, bbcode$
bbcode2$ = UCASE$(bbcode$)
'Befehle seit Version 1.0
IF LEFT$(bbcode2$, 3) = "PRI" THEN GOTO printbe
IF LEFT$(bbcode2$, 3) = "LPR" THEN GOTO lprintbe
IF LEFT$(bbcode2$, 3) = "PAU" THEN GOTO pausebe
IF LEFT$(bbcode2$, 3) = "WAI" THEN GOTO waitbe
IF LEFT$(bbcode2$, 3) = "SHE" THEN GOTO shellbe
IF LEFT$(bbcode2$, 3) = "INP" THEN GOTO inputbe
IF LEFT$(bbcode2$, 3) = "CLS" THEN GOTO clearbe
'Befehle seit Version 1.1
IF LEFT$(bbcode2$, 3) = "BAT" THEN GOTO batch
IF LEFT$(bbcode2$, 4) = "BEEP" THEN BEEP
IF LEFT$(bbcode2$, 4) = "BEEP" THEN GOTO nextzeile
'Befehle seit Version 1.3
IF LEFT$(bbcode2$, 4) = "GOTO" THEN GOTO gotobe
IF LEFT$(bbcode2$, 3) = "GIV" THEN GOTO givebe
IF LEFT$(bbcode2$, 2) = "DO" THEN GOTO dobe
IF LEFT$(bbcode2$, 4) = "PLAY" THEN GOTO playbe

'Dieser IF-Block hier ergibt zwar keinen Sinn, ist aber fr den Programmierer
'bersichtlicher.
IF LEFT$(bbcode2$, 3) = "END" THEN GOTO nextzeile
IF LEFT$(bbcode2$, 1) = "'" THEN GOTO nextzeile
IF RIGHT$(bbcode2$, 1) = ":" THEN GOTO nextzeile
IF RIGHT$(bbcode2$, 1) = "#" THEN GOTO nextzeile
GOTO nextzeile

'=====================BEGIN DES PROGRAMMIERSPRACHEN-FUNKTIONSBLOCKS===========
'In diesem Block befinden sich alle Funktionen der Befehle.
'Jeder Befehl ist durch eine aus "-"en bestehende Linie getrennt.

'-------------------------------------------------------------------------
printbe:
'Schreibe etwas auf Bildschirm.
'Beispiel: PRINT Hallo !
text$ = MID$(bbcode$, 7)

IF RIGHT$(text$, 1) = "/" THEN GOTO weiter10
IF RIGHT$(text$, 1) = "$" THEN GOTO svariaus1
IF RIGHT$(text$, 1) = "!" THEN GOTO nvariaus1
weiter10:
textlang = LEN(text$)
text$ = LEFT$(text$, textlang - 1)
PRINT text$
GOTO nextzeile

svariaus1:
OPEN "strings.tmp" FOR INPUT AS #3
DO UNTIL EOF(3)
INPUT #3, varname$, wert$
IF text$ = varname$ THEN PRINT wert$
LOOP
CLOSE #3
GOTO nextzeile


nvariaus1:
OPEN "numbers.tmp" FOR INPUT AS #3
DO UNTIL EOF(3)
INPUT #3, varname$, wert
IF text$ = varname$ THEN PRINT wert
LOOP
CLOSE #3
GOTO nextzeile


'-------------------------------------------------------------------------

lprintbe:
'Drucke Text auf dem Drucker LPT-1 aus.
'Beispiel: LPRINT Hallo !
text$ = MID$(bbcode$, 8)


IF RIGHT$(text$, 1) = "$" THEN GOTO svariaus2
IF RIGHT$(text$, 1) = "!" THEN GOTO nvariaus2
LPRINT text$
GOTO nextzeile
svariaus2:
OPEN "strings.tmp" FOR INPUT AS #3
DO UNTIL EOF(3)
INPUT #3, varname$, wert$
IF text$ = varname$ THEN LPRINT wert$
LOOP
CLOSE #3
GOTO nextzeile


nvariaus2:
OPEN "numbers.tmp" FOR INPUT AS #3
DO UNTIL EOF(3)
INPUT #3, varname$, wert
IF text$ = varname$ THEN LPRINT wert
LOOP
CLOSE #3

GOTO nextzeile

'-------------------------------------------------------------------------

pausebe:
'Warte bis Benutzer eine Taste drckt.
'Beispiel: PAUSE
PRINT "Weiter mit beliebiger Taste..."
DO
LOOP WHILE INKEY$ = ""
GOTO nextzeile

'-------------------------------------------------------------------------

waitbe:

'Warte eine bestimmten anzahl von Sekunden ab
'Beispiel: WAIT=1

'Lese ekundenanzahl aus den Code:
laenge$ = MID$(bbcode$, 6)
'Forme laenge$ in laenge% um:
laenge% = VAL(laenge$)

'Ausfhren
SLEEP laenge%
GOTO nextzeile

'-------------------------------------------------------------------------

shellbe:
'Befehl an der MS-DOS Shell ausfhren.
'Beispiel: SHELL dir *.exe

makeonshell$ = MID$(bbcode$, 7)

IF RIGHT$(makeonshell$, 1) = "$" THEN GOTO loadstring1
SHELL makeonshell$
GOTO nextzeile
loadstring1:
OPEN "strings.tmp" FOR INPUT AS #6
DO UNTIL EOF(6)
INPUT #6, varname$, wert$
IF varname$ = makeonshell$ THEN SHELL wert$
LOOP
GOTO nextzeile

'-------------------------------------------------------------------------

inputbe:
'Eingabe von Text in eine Variable.
'Beispiel: INPUT Bitte was eingeben:/variable1$
'          INPUT Bitte Zahl eingeben:/zahl1!

text$ = ""
lang1 = 7
textlang = LEN(bbcode$)
weiter6:
buchstabe1$ = MID$(bbcode$, lang1, 1)
IF buchstabe1$ = "/" THEN GOTO weiter7
text$ = text$ + buchstabe1$
lang1 = lang1 + 1
IF lang1 > textlang THEN GOTO nextzeile
GOTO weiter6
weiter7:
varname2$ = MID$(bbcode$, lang1 + 1)
PRINT text$;
INPUT "", eingabe$
IF RIGHT$(bbcode$, 1) = "$" THEN GOTO instring
IF RIGHT$(bbcode$, 1) = "!" THEN GOTO innumber

instring:
NAME "strings.tmp" AS "strings.alt"
OPEN "strings.tmp" FOR APPEND AS #7
OPEN "strings.alt" FOR INPUT AS #6
DO UNTIL EOF(6)
INPUT #6, varname$, wert$
IF varname$ = varname2$ THEN GOTO weiter8
WRITE #7, varname$, wert$
weiter8:
LOOP
CLOSE #6
varname$ = varname2$
wert$ = eingabe$
WRITE #7, varname$, wert$
CLOSE #7
SHELL "del strings.alt"
'Hier wird die ausgabe der Shell 'datei gelscht' berschrieben
PRINT "                          "
GOTO nextzeile

innumber:
eingabe = VAL(eingabe$)
NAME "numbers.tmp" AS "numbers.alt"
OPEN "numbers.tmp" FOR APPEND AS #7
OPEN "numbers.alt" FOR INPUT AS #6
DO UNTIL EOF(6)
INPUT #6, varname$, wert
IF varname$ = varname2$ THEN GOTO weiter9
WRITE #7, varname$, wert
weiter9:
LOOP
CLOSE #6
varname$ = varname2$
wert = eingabe
WRITE #7, varname$, wert
CLOSE #7
SHELL "del numbers.alt"
'Hier wird die ausgabe der Shell 'datei gelscht' berschrieben
PRINT "                         "
GOTO nextzeile



'-------------------------------------------------------------------------

clearbe:
'Lschen des Bildschirms. Beispiel: CLS
CLS
GOTO nextzeile

'-------------------------------------------------------------------------


batch:
'Erlaubt die einbindung von Batchprogrammen in BatchBASIC-Programme
'Beispiel:  BATCH=START
'           @echo off
'           echo Hallo Welt !
'           pause
'           BATCH=END
OPEN "temp.bat" FOR APPEND AS #3
andnext:
INPUT #1, bbcode$
bbcode2$ = UCASE$(bbcode$)
IF LEFT$(bbcode2$, 9) = "BATCH=END" THEN GOTO weiter
PRINT #3, bbcode$
GOTO andnext
weiter:
CLOSE #3
'Starten des Batchprogramms
SHELL "temp"
'Und, da wir das Batchprogramm nicht mehr brauchen...
SHELL "del temp.bat"
GOTO nextzeile
'-------------------------------------------------------------------------
gotobe:
'Springt zu einer Sprungmarke
'Beispiel:   #marke1
'            print Dies ist ein Endlosprogramm
'            goto marke1
markname$ = MID$(bbcode$, 6)
markesuch = 1
EXIT DO


'-------------------------------------------------------------------------
givebe:
'Gibt Variable einen Wert.
'Beispiel: give variable1$=Hallo !
'          give variable2!=12345

'Dank an Fabian Holzner fr die Vorversion dieses Befehls (SET).


'Herrausfinden des Typs (String oder Number) der Variable
vartyp$ = ""
solang1 = LEN(bbcode$)
lang1 = 6
weiter1:
vartyp2$ = MID$(bbcode$, lang1, 1)
IF vartyp2$ = "$" THEN GOTO strings
IF vartyp2$ = "!" THEN GOTO numbers
lang1 = lang1 + 1
IF lang1 > solang1 THEN GOTO nextzeile
GOTO weiter1

strings:
varname$ = ""
'Herrausfinden des Namens der Variable
lang1 = 6
weiter2:
wenngleich$ = MID$(bbcode$, lang1, 1)
IF wenngleich$ = "=" THEN GOTO weiter3
varname$ = varname$ + wenngleich$
lang1 = lang1 + 1
IF lang1 > solang1 THEN GOTO nextzeile
GOTO weiter2

weiter3:
'Herrausfinden des Wertes
lang1 = lang1 + 1
wert$ = MID$(bbcode$, lang1)

'Speichern in strings.tmp

OPEN "strings.tmp" FOR APPEND AS #2
WRITE #2, varname$, wert$
CLOSE #2
GOTO nextzeile

numbers:
varname$ = ""
'Herrausfinden des Namens der Variable
lang1 = 6
weiter4:
wenngleich$ = MID$(bbcode$, lang1, 1)
IF wenngleich$ = "=" THEN GOTO weiter5
varname$ = varname$ + wenngleich$
lang1 = lang1 + 1
IF lang1 > solang1 THEN GOTO nextzeile
GOTO weiter4

weiter5:
'Herrausfinden des Wertes
lang1 = lang1 + 1
wert$ = MID$(bbcode$, lang1)
wert = VAL(wert$)

'Speichern in numbers.tmp

OPEN "numbers.tmp" FOR APPEND AS #2
WRITE #2, varname$, wert
CLOSE #2
GOTO nextzeile
'-------------------------------------------------------------------------
dobe:
' Erstellt eine DO/LOOP UNTIL Schleife
' Beispiel:
' DO (
' Print Hallo
' ) 2
'
' Der Text Hallo wird hier 2mal ausgegeben!

'Dank an Sebastian Kaspari (Q-System) fr die entwicklung dieses Befehls
docheck$ = "0"
DO:
INPUT #1, bbcode$
bbcode2$ = UCASE$(bbcode$)
OPEN "do.dat" FOR OUTPUT AS #2
IF LEFT$(bbcode2$, 1) = ")" THEN docheck$ = "1"
IF docheck$ = "0" THEN INPUT #2, bbcode2$
LOOP UNTIL docheck$ = "1"
CLOSE #2
END



'-------------------------------------------------------------------------
playbe:
'Spielt eine Melodie ab
'Beispiel: PLAY abde

'Dank an Sebastian Kaspari (Q-System) fr die Vorversion dieses Befehls.
musik$ = MID$(bbcode$, 7)

'Gucke, ob musik$ eine Variable ist
IF RIGHT$(musik$, 1) = "$" THEN GOTO loadstring2
PLAY musik$
GOTO nextzeile

loadstring2:
'Srings werden geladen
OPEN "strings.tmp" FOR INPUT AS #4
DO UNTIL EOF(4)
INPUT #4, varname$, wert$
IF varname$ = musik$ THEN PLAY wert$
LOOP
GOTO nextzeile



'==============================ENDE FUNKTIONEN-BLOCK=========================

nextzeile:
LOOP UNTIL bbcode2$ = "END"
CLOSE #1
IF markesuch = 1 THEN GOTO anfang
COLOR 7, 0
'Lschen der Temporren Dateien (wenn vorhanden)
SHELL "del strings.tmp"
SHELL "del numbers.tmp"
SHELL "del strings.alt"
SHELL "del numbers.alt"
CLS
END

error1:
COLOR 4, 0
PRINT "Datei erforderlich !"
COLOR 7, 0
PRINT
PRINT "Bitte benutzen Sie"
COLOR 14, 0
PRINT "bbasic dateiname.bbf"
COLOR 7, 0
PRINT
PRINT "J.M.K S.F. BatchBASIC kehrt zu MS-DOS zurck..."
SLEEP 4
CLS
END



